package com.perforce.maven.scm.provider.p4.util;

import java.util.Arrays;
import java.util.HashSet;

import org.codehaus.plexus.util.StringUtils;

public class P4Port
{
    public static final String[] PROTOCOLS = { "tcp", "tcp4", "tcp6", "tcp46", "tcp64", "ssl", "ssl4", "ssl6", "ssl46",
        "ssl64" };

    private String protocol;

    public String getProtocol()
    {
        return protocol;
    }

    public String getHost()
    {
        return host;
    }

    public String getPort()
    {
        return port;
    }

    private String host;

    private String port;

    public P4Port( String p4Port )
    {
        if ( StringUtils.isBlank( p4Port ) )
        {
            return;
        }

        String originalP4Port = p4Port;

        // extract protocol
        String protocol = null;
        int i0 = p4Port.indexOf( ":" );
        if ( i0 > 0 )
        {
            protocol = p4Port.substring( 0, i0 );
            HashSet<String> protocols = new HashSet<String>( Arrays.asList( PROTOCOLS ) );
            if ( protocols.contains( protocol ) )
            {
                p4Port = p4Port.substring( i0 + 1 );
            }
            else
            {
                protocol = null;
            }
        }

        String[] tokens = StringUtils.split( p4Port, ":" );

        switch ( tokens.length )
        {
            case 2:
                host = tokens[0];
                port = tokens[1];
                break;
            case 1:
                host = tokens[0];
                break;
            default:
                throw new IllegalArgumentException( "Illegal p4port settings: " + originalP4Port );

        }

    }
}